

function varargout = Figure(varargin)
% FIGURE M-file for Figure.fig
%      FIGURE, by itself, creates a new FIGURE or raises the existing
%      singleton*.
%
%      H = FIGURE returns the handle to a new FIGURE or the handle to
%      the existing singleton*.
%
%      FIGURE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FIGURE.M with the given input arguments.
%
%      FIGURE('Property','Value',...) creates a new FIGURE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Figure_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Figure_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Figure

% Last Modified by GUIDE v2.5 18-Feb-2012 08:41:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Figure_OpeningFcn, ...
                   'gui_OutputFcn',  @Figure_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Figure is made visible.
function Figure_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Figure (see VARARGIN)

% Choose default command line output for Figure
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Figure wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Figure_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    
 
 
    %inicializace GUI
    cla;
    cla(handles.axeBest,'reset')
    cla(handles.axeStatistic,'reset');
    cla(handles.axes1,'reset');
    set(handles.stav,'String','Sputno')
    set(handles.funkce,'String','  ')
    set(handles.ohodnoceni,'String','  0 ')
    set(handles.testu,'String',get(handles.numtest,'String'));
    set(handles.test,'String',' 0 ');
    set(handles.nejlepsi,'String',' " "');
    axes(handles.axes1);
    
    
    
    % nacteni parametru 
    gram = get(handles.gram,'String');
    model = get(handles.model,'String'); %stale nepotrebny
    sol = get(handles.solver,'String'); 
    javaaddpath(sol);
    txt = get(handles.txtsave,'String'); 
    generations = str2num(get(handles.generace,'String'));
    spravnost = str2num(get(handles.spravnost,'String'));
    diff = str2num(get(handles.diff,'String'));
    testu = str2num(get(handles.numtest,'String'));
    ctenost = zeros([(str2num(get(handles.readnum,'String'))+2) 1])
    e = 0.5;

    
    if(get(handles.checkbox1,'Value')== 1)
        u = 1;
    else
        u = 0;
    end
    
    %objekt na uloen
    data = Support.Data2(generations, testu); 
   
    
    % zjisteni typu optimalizace
    list=get(handles.vypocet,'String');
    val=get(handles.vypocet,'Value');
    vypocet=list{val}

    %nastaveni parametru pro javasolver
    m = Support.Parameters;
 
    m.SetPopulation(str2num(get(handles.jedincu,'String')));
    m.SetBits(str2num(get(handles.bity,'String')));
	m.SetKodons(str2num(get(handles.kodons,'String')));
    m.SetSelection(str2num(get(handles.selekce,'String')))
    m.SetGrammar(gram);
    m.SetMutation(str2num(get(handles.mutace,'String')));
    m.SetReadNum(str2num(get(handles.readnum,'String')));
    m.SetUnReaded(get(handles.unread,'String'));
    m.SetElitismus(str2num(get(handles.elitismus,'String')));
    m.SetStruct(str2num(get(handles.fulltree,'String')));
    
    %turnaj
    turnaj = 'standard';
    %turnaj = 'female'
    
    %cas startu
    T1 = cputime;

    %hlavni cyklus testu
    for k = 0:(testu-1);
       cla(handles.axes1,'reset');
       axis([-1 12 -1 2]); 
       %prvni vykresleni pred startem 
       X = 0:(0.1):9.9;
       kk = 0;
       for n = 1:100;
        if(X(n) > 00)
           kk = 1;
        end
        yR(n) = 0 + kk;
       end
       
       hs = plot(handles.axes1,X,yR);
       hold all;
       set(hs,'color',[1,0.8,0],'linewidth',5);
       axis(handles.axes1, [-1 12 -1 2]);
       set(handles.test,'String',num2str(k+1));
       pause(0.001)
        
      %nastaven konec
        
       
       % nahodne generace
       engine = Main.Evolution(m); 
       c = engine.GetFittnes()

       As = engine.GetDecodedPopulation();
       As
       for n = 1 : length(As)
        str = Regulator.ModifyString(As(n));
        A(n) = str.GetString();
       end
             for n = 1:length(As);
                 c(n) = Simulace(As(n), c(n), yR, X,vypocet,e, model);
             end
      c
      pause(10)
       
       %nastaven prvnotnho fitnes, a nult generace
       engine.SetFittnes(c);
       gen = 0;
         

     
       %hlavni cyklus    
       while (gen < generations)
           Tc = cputime;
           c = engine.GetFittnes();
            
           using_arrayop = [ int2str(gen + 1), ' ', 'z', ' ' , int2str(generations)];
           set(handles.stav,'String', char(using_arrayop));
        
        
           %provede zazlohovn
           %nejlepch jedinc
           engine.NextGeneration1();

           %matice textovych retezcu
           As = engine.GetDecodedPopulation();
           for n = 1 : length(As)
             str = Regulator.ModifyString(As(n));
             A(n) = str.GetString();
           end

           %ohodnocen kadho
           %jedince
           for n = 1:length(As);
               c(n) = Simulace(As(n), c(n), yR, X, vypocet, e, model);
           end
             
           %nastaven ohodnocen jedinc
           engine.SetFittnes(c); 
        
           %prepise elitismem nejhorsi jedince 
           engine.NextGeneration2(turnaj);
        
           %zpis nejlepsich vysledku
           nejlepsi = engine.GetBest();
           nejlepsihodnota = engine.GetBestValue()

  
           set(handles.funkce,'String', char(nejlepsi(1)));
           set(handles.ohodnoceni,'String', nejlepsihodnota);

           %Uloen hodnot do data
           Sle  = Simulace(nejlepsi, nejlepsihodnota, yR, X,'SALE', e, model)
           str = Regulator.ModifyString(nejlepsi);
           reg = Regulator.RegulatorParser(str.GetString());
                
        
           
           if( strcmp(vypocet,'STE'))
               koef = 1;
           else
               koef = -1;
           end
                
           data.AddNejlepsi(nejlepsihodnota*(koef),gen,k);
           data.AddString(nejlepsi,gen,k);
           data.AddSLE(roundMe(Sle*(-1),2),gen,k);
 
         
         
          %Vykresleni nejlesiho jedince
          cla(handles.axes1,'reset');
          
          h1= plot(handles.axes1,X,yR);
          set(h1,'color',[1,0.8,0],'linewidth',6);
          axis(handles.axes1, [-1 12 -1 2]);
          hold all;
          y2 = Yvalues(nejlepsi, model);
          y2
          X
          h2 = plot(handles.axes1,X,y2);  
          set(h2,'color',[0.1,0.25,0.75],'linewidth',2);
          axis(handles.axes1, [-1 12 -1 2]);
          pause(0.0001);
         
         if(strcmp(vypocet,'STE'))
           if(max(c) >  (spravnost-1))
               e = e - e/100*diff;
           end
           MAX = Max(e,X,yR);
           MIN = Min(e,X,yR);
           hmax = plot(handles.axes1,X,MAX);
           hold all;
           hmin = plot(handles.axes1,X,MIN);
           hold all;
           set(hmin,'color',[1,0,0],'linewidth',2);
           set(hmax,'color',[1,0,0],'linewidth',2);
         end

         %pridani generace
         gen = gen + 1;
        
       
       
    end %konec hlavniho cyklu
    
                cla(handles.axes1,'reset');
                BB = data.GetNejlepsiJedinec()
                nejlepsiEver =  data.GetNejlepsiJedinec();
   
                y2 = Yvalues(nejlepsiEver, model);
                
                h1= plot(handles.axes1,X,yR);
                set(h1,'color',[1,0.8,0],'linewidth',6);
                hold all;
                axis(handles.axes1, [-1 12 -1 2]); 
      
                h2 = plot(handles.axes1,X,y2);
                set(h2,'color',[0.1,0.25,0.75],'linewidth',2);
                axis(handles.axes1, [-1 12 -1 2]); 
      
                
        
     % statistika dekodovani a poctu cteni jedincu   
     nedekodovano = engine.GetUndecoded();
     cteni = engine.GetReadNum();

      for i=1:length(cteni)
       ctenost(i) = ctenost(i)+cteni(i);
      end
     
   end
 
    
    %vypocet a nastaveni poctu dekodovani
    pocet = sum(ctenost);
    
    for i=1:length(ctenost)
      procento = ctenost(i)/pocet*100
      line = strcat( int2str(i-1), '*', ' ', ' => ' , int2str(ctenost(i)), '  -  ', int2str(procento), ' %' );
      if(i == (length(ctenost)-1))
          line = strcat( int2str(i-1), '*', ' ', ' => ' , int2str(ctenost(i)), '  -  ', int2str(procento), ' %' );
      end
      if(i == length(ctenost))
          line = strcat( 'Chyba', ' ', ' => ' , int2str(nedekodovano));
      end
      s = char(line);
      s2 = cellstr(s);
      handles.names(i) = s2; % fill handles struct with values that you want like to input in
    end
    set(handles.cteni,'String',handles.names)

    
    median = data.GetMedian()
    aritmetic = data.GetAritmetic()
    elite = data.GetBestAritmetic()
    sle = data.GetAritmeticSLE()
    
    maxx(1) = aritmetic(1);
    maxx(2) = median(1);
    maxx(3) = sle(1);

    nejlepsi_promerny_vysledek = aritmetic(generations)
     MaxValue = max(maxx);
            if(MaxValue > 10*nejlepsi_promerny_vysledek)
                MaxValue = 10*nejlepsi_promerny_vysledek;
            end
  
        
        
         
 
  % vypsani nejlepsiho jedince
  s = data.GetNejlepsiJedinec();
  s2 = char(s);
  set(handles.nejlepsi,'String',s2);
  
  set(handles.stav,'String', 'Vyhodnoceno');
  set(handles.funkce,'String', char(s))
    
           
  
 

  x = 1:generations;
  
  p = plot(handles.axeBest,x,elite);
  axis(handles.axeBest, [-1 generations+1 -1 elite(generations)+10]);
  
  axes(handles.axeStatistic);
  hold all;
  p = plot(handles.axeStatistic,x,sle);
  hold all;
  set(p,'Color','red','LineWidth',2)
  
  p = plot(handles.axeStatistic,x,aritmetic);
  hold all;
  set(p,'Color','blue','LineWidth',2)
  
  p = plot(handles.axeStatistic,x,median);
  hold all;
  set(p,'Color','green','LineWidth',2)
  axis(handles.axeStatistic, [-1 generations+1 -1 MaxValue+10]); 
  legend('SALE','Aritmetick prmr', 'Medin');

  %ulozeni vysledku
         if(u == 1)
           s = ['Jedincu: ' get(handles.jedincu,'String') ' \r Kodonu: ' get(handles.kodons,'String') 'Bit: '  get(handles.bity,'String') 'Sla selekce: ' get(handles.selekce,'String') 'Gramatika: ' gram 'Mutace: ' get(handles.mutace,'String') 'Poet ten: ' get(handles.readnum,'String') 'nedekodovan len: ' get(handles.unread,'String') 'Elitismus ' get(handles.elitismus,'String') 'Strukturln ken: ' get(handles.fulltree,'String') ];
           data.SetFile(txt);
           data.Save(s);
         end
        




function jedincu_Callback(hObject, eventdata, handles)
% hObject    handle to jedincu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of jedincu as text
%        str2double(get(hObject,'String')) returns contents of jedincu as a double


% --- Executes during object creation, after setting all properties.
function jedincu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to jedincu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function nummutace_Callback(hObject, eventdata, handles)
% hObject    handle to nummutace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nummutace as text
%        str2double(get(hObject,'String')) returns contents of nummutace as a double


% --- Executes during object creation, after setting all properties.
function nummutace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nummutace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tolerance_Callback(hObject, eventdata, handles)
% hObject    handle to tolerance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tolerance as text
%        str2double(get(hObject,'String')) returns contents of tolerance as a double


% --- Executes during object creation, after setting all properties.
function tolerance_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tolerance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function looking_Callback(hObject, eventdata, handles)
% hObject    handle to looking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of looking as text
%        str2double(get(hObject,'String')) returns contents of looking as a double


% --- Executes during object creation, after setting all properties.
function looking_CreateFcn(hObject, eventdata, handles)
% hObject    handle to looking (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mutace_Callback(hObject, eventdata, handles)
% hObject    handle to mutace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mutace as text
%        str2double(get(hObject,'String')) returns contents of mutace as a double


% --- Executes during object creation, after setting all properties.
function mutace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mutace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function readnum_Callback(hObject, eventdata, handles)
% hObject    handle to readnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of readnum as text
%        str2double(get(hObject,'String')) returns contents of readnum as a double


% --- Executes during object creation, after setting all properties.
function readnum_CreateFcn(hObject, eventdata, handles)
% hObject    handle to readnum (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function nahoda_Callback(hObject, eventdata, handles)
% hObject    handle to nahoda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nahoda as text
%        str2double(get(hObject,'String')) returns contents of nahoda as a double


% --- Executes during object creation, after setting all properties.
function nahoda_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nahoda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fulltree_Callback(hObject, eventdata, handles)
% hObject    handle to fulltree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fulltree as text
%        str2double(get(hObject,'String')) returns contents of fulltree as a double


% --- Executes during object creation, after setting all properties.
function fulltree_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fulltree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function struktural_Callback(hObject, eventdata, handles)
% hObject    handle to fulltree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fulltree as text
%        str2double(get(hObject,'String')) returns contents of fulltree as a double


% --- Executes during object creation, after setting all properties.
function struktural_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fulltree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function turnaj_Callback(hObject, eventdata, handles)
% hObject    handle to turnaj (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of turnaj as text
%        str2double(get(hObject,'String')) returns contents of turnaj as a double


% --- Executes during object creation, after setting all properties.
function turnaj_CreateFcn(hObject, eventdata, handles)
% hObject    handle to turnaj (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function selekce_Callback(hObject, eventdata, handles)
% hObject    handle to selekce (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of selekce as text
%        str2double(get(hObject,'String')) returns contents of selekce as a double


% --- Executes during object creation, after setting all properties.
function selekce_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selekce (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function speed_Callback(hObject, eventdata, handles)
% hObject    handle to speed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of speed as text
%        str2double(get(hObject,'String')) returns contents of speed as a double


% --- Executes during object creation, after setting all properties.
function speed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to speed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function generace_Callback(hObject, eventdata, handles)
% hObject    handle to generace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of generace as text
%        str2double(get(hObject,'String')) returns contents of generace as a double


% --- Executes during object creation, after setting all properties.
function generace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to generace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function kodons_Callback(hObject, eventdata, handles)
% hObject    handle to kodons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of kodons as text
%        str2double(get(hObject,'String')) returns contents of kodons as a double


% --- Executes during object creation, after setting all properties.
function kodons_CreateFcn(hObject, eventdata, handles)
% hObject    handle to kodons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function bity_Callback(hObject, eventdata, handles)
% hObject    handle to bity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of bity as text
%        str2double(get(hObject,'String')) returns contents of bity as a double


% --- Executes during object creation, after setting all properties.
function bity_CreateFcn(hObject, eventdata, handles)
% hObject    handle to bity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gram_Callback(hObject, eventdata, handles)
% hObject    handle to gram (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gram as text
%        str2double(get(hObject,'String')) returns contents of gram as a double


% --- Executes during object creation, after setting all properties.
function gram_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gram (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function solver_Callback(hObject, eventdata, handles)
% hObject    handle to solver (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of solver as text
%        str2double(get(hObject,'String')) returns contents of solver as a double


% --- Executes during object creation, after setting all properties.
function solver_CreateFcn(hObject, eventdata, handles)
% hObject    handle to solver (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function model_Callback(hObject, eventdata, handles)
% hObject    handle to model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of model as text
%        str2double(get(hObject,'String')) returns contents of model as a double


% --- Executes during object creation, after setting all properties.
function model_CreateFcn(hObject, eventdata, handles)
% hObject    handle to model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function unread_Callback(hObject, eventdata, handles)
% hObject    handle to unread (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of unread as text
%        str2double(get(hObject,'String')) returns contents of unread as a double


% --- Executes during object creation, after setting all properties.
function unread_CreateFcn(hObject, eventdata, handles)
% hObject    handle to unread (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on selection change in vypocet.
function vypocet_Callback(hObject, eventdata, handles)
% hObject    handle to vypocet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% Hints: contents = cellstr(get(hObject,'String')) returns vypocet contents as cell array
%        contents{get(hObject,'Value')} returns selected item from vypocet


% --- Executes during object creation, after setting all properties.
function vypocet_CreateFcn(hObject, eventdata, handles)
% hObject    handle to vypocet (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function elitismus_Callback(hObject, eventdata, handles)
% hObject    handle to elitismus (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of elitismus as text
%        str2double(get(hObject,'String')) returns contents of elitismus as a double


% --- Executes during object creation, after setting all properties.
function elitismus_CreateFcn(hObject, eventdata, handles)
% hObject    handle to elitismus (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function spravnost_Callback(hObject, eventdata, handles)
% hObject    handle to spravnost (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of spravnost as text
%        str2double(get(hObject,'String')) returns contents of spravnost as a double


% --- Executes during object creation, after setting all properties.
function spravnost_CreateFcn(hObject, eventdata, handles)
% hObject    handle to spravnost (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function diff_Callback(hObject, eventdata, handles)
% hObject    handle to diff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of diff as text
%        str2double(get(hObject,'String')) returns contents of diff as a double


% --- Executes during object creation, after setting all properties.
function diff_CreateFcn(hObject, eventdata, handles)
% hObject    handle to diff (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function body_Callback(hObject, eventdata, handles)
% hObject    handle to body (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of body as text
%        str2double(get(hObject,'String')) returns contents of body as a double


% --- Executes during object creation, after setting all properties.
function body_CreateFcn(hObject, eventdata, handles)
% hObject    handle to body (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2
  

% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1



function numtest_Callback(hObject, eventdata, handles)
% hObject    handle to numtest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numtest as text
%        str2double(get(hObject,'String')) returns contents of numtest as a double


% --- Executes during object creation, after setting all properties.
function numtest_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numtest (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key release with focus on figure1 or any of its controls.
function figure1_WindowKeyReleaseFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was released, in lower case
%	Character: character interpretation of the key(s) that was released
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) released
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function txtsave_Callback(hObject, eventdata, handles)
% hObject    handle to txtsave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtsave as text
%        str2double(get(hObject,'String')) returns contents of txtsave as a double


% --- Executes during object creation, after setting all properties.
function txtsave_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtsave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in lfunkce.
function lfunkce_Callback(hObject, eventdata, handles)
% hObject    handle to lfunkce (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val = get(hObject,'Value');
switch val
case 1
     funkce = 'sin(2*X)';
     start = 0.00000001;
     Interval = 4 * pi;
     points = 100;
     cla(handles.axes1,'reset')
     f = inline(funkce);
     x = start:Interval/points:(Interval+start);
     for n = 1:length(x);
       y(n) = f(x(n)); 
     end
     hs = plot(handles.axes1,x,y);
     set(hs,'color',[1,0.8,0],'linewidth',5);
     axis(handles.axes1, [-1 Interval+start+1 -2 2]);
case 2
     funkce = '(X)*(X)/(3+sin(2*X))';
     start = -5;
     Interval = 8;
     points = 100;
     cla(handles.axes1,'reset')
     f = inline(funkce);
     x = start:Interval/points:(4);
     for n = 1:length(x);
       y(n) = f(x(n)); 
     end
     hs = plot(handles.axes1,x,y);
     set(hs,'color',[1,0.8,0],'linewidth',5);
     axis(handles.axes1, [start-1 5 -4 9]);
case 3
     funkce = 'X*X/2';
     start = -5;
     Interval = 10;
     points = 100;
     cla(handles.axes1,'reset')
     f = inline(funkce);
     x = start:Interval/points:(Interval+start);
     for n = 1:length(x);
       y(n) = f(x(n)); 
     end
     hs = plot(handles.axes1,x,y);
     set(hs,'color',[1,0.8,0],'linewidth',5);
     axis(handles.axes1, [start-1 Interval+start+1 -2.5 20]);   
case 4
     interval = 11
     x = -1:(interval/100):interval
     k = 0;
     for n = 1:110;
       if(x(n) > 00)
           k = 1;
        end
       y(n) = 0 + k;
       
     end
     start = -1;
     Interval = 11;
     cla(handles.axes1,'reset')
     hs = plot(handles.axes1,x,y);
     set(hs,'color',[1,0.8,0],'linewidth',5);
     axis(handles.axes1, [start-1 12 -1 2]);
     
end 

% Hints: contents = cellstr(get(hObject,'String')) returns lfunkce contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lfunkce


% --- Executes during object creation, after setting all properties.
function lfunkce_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lfunkce (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in togglebutton3.
function togglebutton3_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton3




function maxgen_Callback(hObject, eventdata, handles)
% hObject    handle to maxgen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxgen as text
%        str2double(get(hObject,'String')) returns contents of maxgen as a double


% --- Executes during object creation, after setting all properties.
function maxgen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxgen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3


% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in menu.
function menu_Callback(hObject, eventdata, handles)
% hObject    handle to menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from menu


% --- Executes during object creation, after setting all properties.
function menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

path = get(handles.txtsave,'String')
sol = get(handles.solver,'String'); 
javaaddpath(sol);

read = Support.ReadFile(path); 
data = Support.Parser(read.GetRows())
data.Decode();

nejlepsi = data.GetNejlepsi()
string = data.GetNejlepsiString()
interval = data.GetInterval()
SLE = data.GetSLE()

a = size(nejlepsi);
b = size(interval);
c = size(SLE);

nejJava = javaArray ('java.lang.Double', a(1), a(2));

for m = 1:a(1)
   for n = 1:a(2)
    nejJava(m,n) = java.lang.Double(nejlepsi(m,n));
   end
end

intJava = javaArray ('java.lang.Double', b(1));
for m = 1:b(1)
    intJava(m) = java.lang.Double(interval(m))
end

sleJava = javaArray ('java.lang.Double', c(1), c(2));
for m = 1:c(1)
   for n = 1:c(2)
    sleJava(m,n) = java.lang.Double(SLE(m,n));
   end
end

statistic = Support.Data2();
statistic.SetNejlepsi(nejJava);
statistic.SetNejlepsiString(string);
statistic.SetSLE(sleJava);
statistic.SetInterval(intJava);

    median = statistic.GetMedian()
    aritmetic = statistic.GetAritmetic()
    elite = statistic.GetBestAritmetic()
    sle = statistic.GetAritmeticSLE()
    settings = data.GetSettings()
    
   y1a = aritmetic(a(2))-5
   y2a = aritmetic(1)+5
   
   y1m = median(a(2))-5
   y2m = median(1)+5
   
   x = 1:a(2)
  
  p = plot(handles.axes2,x,aritmetic);
  axis(handles.axes2, [-1 a(1)+1 y1a y2a])
  
  p = plot(handles.axemedian,x,median);
  axis(handles.axemedian, [-1 a(1)+1 y1m y2m])
  
  p = plot(handles.axeBest,x,elite);
  axis(handles.axeBest, [-1 a(1)+1 -1 elite(a(2))+5])
  
  p = plot(handles.axeSLE,x,sle);
  axis(handles.axeSLE, [-1 a(1)+1 -1 sle(a(2))+10])

  s = statistic.GetNejlepsiJedinec()
  s2 = char(sym(char(s)));
  set(handles.nejlepsi,'String',s2);


% --- Executes on selection change in cteni.
function cteni_Callback(hObject, eventdata, handles)
% hObject    handle to cteni (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns cteni contents as cell array
%        contents{get(hObject,'Value')} returns selected item from cteni


% --- Executes during object creation, after setting all properties.
function cteni_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cteni (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu7.
function popupmenu7_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu7 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu7


% --- Executes during object creation, after setting all properties.
function popupmenu7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu8.
function popupmenu8_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu8 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu8


% --- Executes during object creation, after setting all properties.
function popupmenu8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
